local GreatLadder = ...

-- Apply building asset processor
GreatLadder:registerAssetProcessor("models/greatLadder.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
GreatLadder:registerAssetProcessor("models/greatLadder3.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

_GreatLadderBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {1, 1} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
}}
_BridgeBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {0.1, 0.1} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
}}

-- Register all great ladder building parts and their properties
GreatLadder:dofile("scripts/buildings.lua")
GreatLadder:dofile("scripts/buildings3.lua")

-- Register the great ladder monument
GreatLadder:register({
        DataType = "BUILDING",
	Id = _GreatLadderPrefix .. "_MONUMENT",
	Name = _GreatLadderPrefix .. "_NAME",
	Description = _GreatLadderPrefix .. "_DESC",
	BuildingType = "MONUMENT",
        AssetCoreBuildingPart = _BridgePrefix .. "_CORE_PART",
	RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 }
	},
        IsEditable = true
})

-- Register the great ladder decoration
-- Apply building asset processor
GreatLadder:registerAssetProcessor("models/core.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
GreatLadder:registerAssetId("models/core.fbx/Prefab/CoreBuildingPart", _GreatLadderPrefix .. "_CORE_BUILDING_PREFAB")
-- Register the Core part
GreatLadder:register({
	DataType = "BUILDING_PART",
	Id = _GreatLadderPrefix .. "_CORE_BUILDING_PART",
	Name = _GreatLadderPrefix .. "_CORE_BUILDING_NAME",
	Description = _GreatLadderPrefix .. "_CORE_BUILDING_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _GreatLadderPrefix .. "_CORE_BUILDING_PREFAB"
	},
        IsVisibleWhenBuilt = false
})

GreatLadder:register({
        DataType = "BUILDING",
	Id = _GreatLadderPrefix .. "1_MONUMENT",
	Name = _GreatLadderPrefix .. "_NAME",
	Description = _GreatLadderPrefix .. "_DESC",
	BuildingType = "DECORATION",
        AssetCoreBuildingPart = _GreatLadderPrefix .. "_CORE_BUILDING_PART",
        BuildingPartSetList = {
		{
			Name = _GreatLadderPrefix .. "_PARTSETLIST_NAME",
	                BuildingPartList = {
		            _GreatLadderPrefix .. "_ROOT_PART"
                        }
                 }                                     
        },
	RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 }
	},
        IsEditable = true
})



